<div class="enter-summoner-container" *ngIf="!summonerExists">
  <h1>Enter the name of a summoner</h1>
  <app-search></app-search>
</div>

<app-spinner [show]="showSpinner"></app-spinner>

<ng-container *ngIf="summoner?.name">
  <div class="summoner-data">
    <div class="summoner-profile">
      <div class="icon" [style.background-image]="'url(' + summoner.icon + ')'">
        <p>{{ summoner.level }}</p>
      </div>
      <p>{{ summoner.name }}</p>
      <p>EUW</p>
    </div>
    <div class="leagues-container">
      <div class="leagues-data" *ngIf="summoner?.leagues?.solo">
        <img
          [src]="
            summoner.leagues.solo.tier
              ? 'assets/icons/leagues/' +
                summoner.leagues.solo.tier.toLowerCase() +
                '_' +
                summoner.leagues.solo.division +
                '.png'
              : 'assets/icons/leagues/default.png'
          "
        />
        <div>Solo queue</div>
        <div *ngIf="!summoner.leagues.solo.tier">Unranked</div>
        <ng-container *ngIf="summoner.leagues.solo.tier">
          <div>
            {{ summoner.leagues.solo.tier }}
            {{ summoner.leagues.solo.division }}
          </div>
          <div>
            {{ summoner.leagues.solo.points }}LP /
            {{ summoner.leagues.solo.wins }}V
            {{ summoner.leagues.solo.losses }}L
          </div>
          <div>
            Victory ratio
            {{
              (
                (summoner.leagues.solo.wins /
                  (summoner.leagues.solo.wins + summoner.leagues.solo.losses)) *
                100
              ).toFixed(1)
            }}%
          </div>
          <div>{{ summoner.leagues.solo.name }}</div>
        </ng-container>
      </div>
      <div class="leagues-data" *ngIf="summoner?.leagues?.flex">
        <img
          [src]="
            summoner.leagues.flex.tier
              ? 'assets/icons/leagues/' +
                summoner.leagues.flex.tier.toLowerCase() +
                '_' +
                summoner.leagues.flex.division +
                '.png'
              : 'assets/icons/leagues/default.png'
          "
        />
        <div>Ranked Flex</div>
        <div *ngIf="!summoner.leagues.flex.tier">Unranked</div>
        <ng-container *ngIf="summoner.leagues.flex.tier">
          <div>
            {{ summoner.leagues.flex.tier }}
            {{ summoner.leagues.flex.division }}
          </div>
          <div>
            {{ summoner.leagues.flex.points }}LP /
            {{ summoner.leagues.flex.wins }}V
            {{ summoner.leagues.flex.losses }}L
          </div>
          <div>
            Victory ratio
            {{
              (
                (summoner.leagues.flex.wins /
                  (summoner.leagues.flex.wins + summoner.leagues.flex.losses)) *
                100
              ).toFixed(1)
            }}%
          </div>
          <div>{{ summoner.leagues.flex.name }}</div>
        </ng-container>
      </div>
    </div>
  </div>

  <div class="data-section">
    <div class="best-champions-container">
      <h1>Best Champions</h1>
      <div class="champions-container">
        <div
          class="champion"
          [routerLink]="['/', 'champion', champion?.championId]"
          *ngFor="let champion of summoner.champions"
        >
          <a>
            {{ champion.name }}
          </a>
          <img [src]="champion.image" />
        </div>
      </div>
    </div>
    <div class="match-history-container">
      <h1>Match History</h1>
      <div class="match" *ngFor="let match of summoner.matchHistory">
        <mat-expansion-panel
          (opened)="panelOpenState = true"
          (closed)="panelOpenState = false"
          [ngClass]="{ victory: match.summonerWin }"
        >
          <mat-expansion-panel-header>
            <div class="summoner-match-data current-summoner">
              <div class="first-summoner-column">
                <span
                  ><b>{{ match.summonerWin ? "Victory" : "Defeat" }}</b></span
                >
                <div class="champ-summoners-images">
                  <img
                    [routerLink]="[
                      '/',
                      'champion',
                      match.currentSummoner?.championId
                    ]"
                    [src]="match?.currentSummoner?.image?.image | safeHtml"
                  />
                  <div class="summoners-images">
                    <img
                      [matTooltip]="
                        match.currentSummoner?.summonerSpells?.D?.name
                      "
                      [src]="
                        getImageSummonerSpellFullUrl(
                          match.currentSummoner?.summonerSpells?.D?.image?.full
                        ) | safeHtml
                      "
                    />
                    <img
                      [matTooltip]="
                        match.currentSummoner?.summonerSpells?.F?.name
                      "
                      [src]="
                        getImageSummonerSpellFullUrl(
                          match.currentSummoner?.summonerSpells?.F?.image?.full
                        ) | safeHtml
                      "
                    />
                  </div>
                </div>
                {{ match?.currentSummoner?.championName }}
              </div>
              <div class="second-summoner-column">
                <div class="kda-container">
                  {{ match.currentSummoner.stats.kills }} /
                  {{ match.currentSummoner.stats.deaths }} /
                  {{ match.currentSummoner.stats.assists }}
                </div>
                <div class="kda">
                  <ng-container
                    *ngIf="
                      (match.currentSummoner.stats.kills +
                        match.currentSummoner.stats.assists) /
                      match.currentSummoner.stats.deaths
                    "
                  >
                    {{
                      (
                        (match.currentSummoner.stats.kills +
                          match.currentSummoner.stats.assists) /
                        match.currentSummoner.stats.deaths
                      ).toFixed(2)
                    }}
                    KDA</ng-container
                  >
                </div>
                <img
                  class="position-img"
                  [src]="
                    'assets/icons/positions/' +
                    match.currentSummoner.teamPosition +
                    '_icons.png'
                  "
                />
              </div>
              <div class="third-summoner-column">
                <div>Level {{ match.currentSummoner.stats.champLevel }}</div>
                <div>
                  CS
                  {{
                    match.currentSummoner.stats.totalMinionsKilled +
                      match.currentSummoner.stats.neutralMinionsKilled
                  }}
                </div>
                <div>
                  Wards placed {{ match.currentSummoner.stats.wardsPlaced }}
                </div>
              </div>

              <div class="runes">
                <div class="column">
                  <img
                    *ngFor="
                      let rune of match.currentSummoner.runes
                        | keyvalue
                        | slice: 0:4
                    "
                    [matTooltip]="rune.value.name"
                    [src]="
                      getImageRuneFullUrl(rune.value.image.icon) | safeHtml
                    "
                  />
                </div>
                <div class="column">
                  <img
                    *ngFor="
                      let rune of match.currentSummoner.runes
                        | keyvalue
                        | slice: 4:6
                    "
                    [matTooltip]="rune.value.name"
                    [src]="
                      getImageRuneFullUrl(rune.value.image.icon) | safeHtml
                    "
                  />
                </div>
              </div>

              <div class="items">
                <div
                  class="item"
                  *ngFor="let item of match.currentSummoner.items | keyvalue"
                >
                  <img
                    [matTooltip]="item.value.name"
                    [src]="
                      getImageItemFullUrl(item.value.image.full) | safeHtml
                    "
                  />
                </div>
              </div>
            </div>
          </mat-expansion-panel-header>
          <div class="teams-data">
            <div class="objectives-data">
              <div class="objectives">
                <div class="objective">
                  <img
                    matTooltip="Baron"
                    src="assets/icons/objectives/blue-baron.png"
                  />
                  {{ match.teams[0].objectives.baron.kills }}
                </div>
                <div class="objective">
                  <img
                    matTooltip="Dragon"
                    src="assets/icons/objectives/blue-dragon.png"
                  />
                  {{ match.teams[0].objectives.dragon.kills }}
                </div>
                <div class="objective">
                  <img
                    matTooltip="Tower"
                    src="assets/icons/objectives/blue-tower.png"
                  />
                  {{ match.teams[0].objectives.tower.kills }}
                </div>
              </div>
              <div class="objectives-text">Objectives</div>
              <div class="objectives">
                <div class="objective">
                  <img
                    matTooltip="Baron"
                    src="assets/icons/objectives/red-baron.png"
                  />
                  {{ match.teams[1].objectives.baron.kills }}
                </div>
                <div class="objective">
                  <img
                    matTooltip="Dragon"
                    src="assets/icons/objectives/red-dragon.png"
                  />
                  {{ match.teams[1].objectives.dragon.kills }}
                </div>
                <div class="objective">
                  <img
                    matTooltip="Tower"
                    src="assets/icons/objectives/red-tower.png"
                  />
                  {{ match.teams[1].objectives.tower.kills }}
                </div>
              </div>
            </div>
            <div
              *ngFor="let number of [0, 1]"
              class="team"
              [ngClass]="{
                blue: match.teams[number].isWinner,
                red: !match.teams[number].isWinner
              }"
            >
              <div
                class="summoner-match-data"
                *ngFor="let participant of match.teams[number].participants"
              >
                <img
                  [routerLink]="['/', 'champion', participant?.championId]"
                  [src]="participant.image.image | safeHtml"
                />

                <a
                  class="name"
                  [routerLink]="['/', 'summoner', participant.summonerName]"
                >
                  {{ participant.summonerName }}
                </a>
                <div class="summoner-spells">
                  <img
                    [matTooltip]="participant?.summonerSpells?.D?.name"
                    [src]="
                      getImageSummonerSpellFullUrl(
                        participant.summonerSpells?.D?.image?.full
                      ) | safeHtml
                    "
                  />
                  <img
                    [matTooltip]="participant?.summonerSpells?.F?.name"
                    [src]="
                      getImageSummonerSpellFullUrl(
                        participant.summonerSpells?.F?.image?.full
                      ) | safeHtml
                    "
                  />
                </div>
                <div class="kda-container">
                  {{ participant.stats.kills }} /
                  {{ participant.stats.deaths }} /
                  {{ participant.stats.assists }}
                </div>
                <div class="runes">
                  <div
                    class="rune"
                    *ngFor="let rune of participant.runes | keyvalue"
                  >
                    <img
                      [matTooltip]="rune.value.name"
                      [src]="
                        getImageRuneFullUrl(rune.value.image.icon) | safeHtml
                      "
                    />
                  </div>
                </div>

                <div class="items">
                  <div
                    class="item"
                    *ngFor="let item of participant.items | keyvalue"
                  >
                    <img
                      [matTooltip]="item.value.name"
                      [src]="
                        getImageItemFullUrl(item.value.image.full) | safeHtml
                      "
                    />
                  </div>
                </div>
              </div>
              <div
                class="team-footer"
                [ngClass]="{ victory: match.teams[number].isWinner }"
              >
                <span>{{
                  match.teams[number].isWinner ? "Victory" : "Defeat"
                }}</span>
                <span>
                  Total Team Kills:
                  {{ match.teams[number].objectives.champion.kills }}
                </span>
              </div>
            </div>
          </div>
        </mat-expansion-panel>
      </div>

      <button class="moreHistory" (click)="getMoreMatchHistory()">
        More matches
      </button>
    </div>
  </div>
</ng-container>
